// The root URL for the RESTful services
var rootURL = "/aggregator/service";

var defaultPollingTimeMS = 10000;

// questo e' l'oggetto che ci fa da context
var context = {
	token : undefined,
	googleToken : undefined,
	user : {},
	headers : {},
	links : {},
	googleUser : undefined,
	aggregatorUser : undefined
};

$(document).ready(
		function() {

			var headers = {};
			headers['Accept'] = "application/json";
			// Retrieve endpoints when application starts
			doGet(rootURL, null, headers, function(data, textStatus, jqXHR) {
				var hypermedia = data;
				var index;
				for (index in hypermedia['links']) {
					var link = hypermedia['links'][index];
					// this allows a faster link retrieval, given the associated
					// relation
					context.links[link['rel']] = link;
				}

			}, function(jqXHR, textStatus, errorThrown) {
				$("#log").text(
						"get configuration error : " + textStatus + ", "
								+ errorThrown);
			});
			
			(function($) {
				//
				// Usage
			    //
				// $.QueryString["param"]
				$.QueryString = (function(a) {
					if (a == "")
						return {};
					var b = {};
					for (var i = 0; i < a.length; ++i) {
						var p = a[i].split('=');
						if (p.length != 2)
							continue;
						b[p[0]] = decodeURIComponent(p[1].replace(/\+/g, " "));
					}
					return b;
				})(window.location.search.substr(1).split('&'))
			})(jQuery);

			
		});

function doGet(url, params, headers, onSuccess, onError) {
	console.log('perform GET on ' + url);
	$.ajax({
		type : 'GET',
		url : url,
		data : params,
		contentType : "application/json",
		dataType : "json",
		headers : headers,
		success : onSuccess,
		error : onError
	});
}

function doPost(url, content, headers, onSuccess, onError) {
	console.log('perform POST of ' + content + ' on ' + url);
	$.ajax({
		type : 'POST',
		url : url,
		data : content,
		headers : headers,
		success : onSuccess,
		error : onError
	});
}

function doPut(url, content, headers, onSuccess, onError) {
	console.log('perform PUT of ' + content + ' on ' + url);
	$.ajax({
		type : 'PUT',
		url : url,
		data : content,
		headers : headers,
		success : onSuccess,
		error : onError
	});
}

function login() {
	$("#log").text("");
	var loginLink = context.links['LOGIN'];

	var user = $("#user").val();
	var pswd = $("#pswd").val();

	var requestBody = "username=" + user + "&password=" + pswd;

	var headers = {};
	headers['Content-Type'] = "application/x-www-form-urlencoded";
	headers['Accept'] = "application/json";

	doPost(loginLink['href'], requestBody, headers, function(data, textStatus,
			jqXHR) {
		var hypermedia = data;
		var index;
		for (index in hypermedia['links']) {
			var link = hypermedia['links'][index];
			context.links[link['rel']] = link;
		}
		// window.alert("login successful");
		context.aggregatorUser = data;
		context.token = {};
		context.token['value'] = jqXHR.getResponseHeader("Authorized-By");
		context.token['expires'] = jqXHR.getResponseHeader("Expires");

		saveUserLinks(context.aggregatorUser.hypermedia);

		sessionStorage.setItem("context", JSON.stringify(context));
		window.location.href = "user.html";

	}, function(jqXHR, textStatus, errorThrown) {
		$("#log").text("login error : " + textStatus + ", " + errorThrown);
	});
}

function forgotPassword() {
	$("#log").text("");
	var resetLink = context.links['ASK_PWD_RESET'];

	var user = $("#user").val();

	var requestBody = "username=" + user;

	var headers = {};
	headers['Content-Type'] = "application/x-www-form-urlencoded";
	headers['Accept'] = "application/json";

	doPost(
			resetLink['href'],
			requestBody,
			headers,
			function(data, textStatus, jqXHR) {
				$("#log")
						.text(
								"You should soon receive an email with instructions for resetting your password");
				for (index in data['links']) {
					if(data.links[index].rel == 'SELF')
						continue;
					var link = data['links'][index];
					context.links[link['rel']] = link;
				}
			}, function(jqXHR, textStatus, errorThrown) {
				$("#log").text(
						"password reset error : " + textStatus + ", "
								+ errorThrown);
			});
}


function loginGoogle() {
	$("#log").text("");
	var loginLink = context.links['LOGIN'];

	var requestBody = "username=&password=" + context.googleToken.access_token;

	var headers = {};
	headers['Content-Type'] = "application/x-www-form-urlencoded";
	headers['Accept'] = "application/json";

	doPost(loginLink['href'], requestBody, headers,

	function(data, textStatus, jqXHR) {
		var hypermedia = data;
		var index;
		for (index in hypermedia['links']) {
			var link = hypermedia['links'][index];
			context.links[link['rel']] = link;
		}
		// window.alert("login successful");
		context.aggregatorUser = data;
		context.token = {};
		context.token['value'] = jqXHR.getResponseHeader("Authorized-By");
		context.token['expires'] = jqXHR.getResponseHeader("Expires");

		sessionStorage.setItem("context", JSON.stringify(context));
		window.location.href = "user.html";
	}, function(jqXHR, textStatus, errorThrown) {
		$("#log").text("login error : " + textStatus + ", " + errorThrown);
	});
}

function enableRegistration() {
	var t = $("#registration");
	if (t.css("visibility") == "hidden") {
		t.css("visibility", "visible");
	}
}

function checkPasswords() {
	var pasw1 = $("#enterPassword").val();
	var pasw2 = $("#checkPassword").val();
	if (pasw1 == pasw2 && pasw1.length > 0) {
		$("#pswdChecker").text("Passwords are matching!");
		$("#pswdChecker").css("display", "block");
		$("#pswdChecker").css("background-color", "SpringGreen");
		return true;
	} else {
		$("#pswdChecker").text("Error : Passwords are NOT matching!");
		$("#pswdChecker").css("display", "block");
		$("#pswdChecker").css("background-color", "Tomato");
		return false;
	}
}

function validateRegistrationForm() {
	var passwordsAreMatching = checkPasswords();
	if (!passwordsAreMatching) {
		$("#registrationLog").text(
				"Error : the provided passwords are not matching.");
	}
	var pasw1 = $("#enterPassword").val();
	var email = $("#email").val();
	if (pasw1 === undefined || pasw1.length < 8 || pasw1.length > 16) {
		$("#registrationLog")
				.text(
						"Error : password length should be between 8 and 16 characters");
		return false;
	}
	if (pasw1 == email) {
		$("#registrationLog").text(
				"Error: Password must be different from email!");
		$("#enterPassword").focus();
		return false;
	}
	var regExp = /[0-9]/;
	if (!regExp.test(pasw1)) {
		$("#registrationLog").text(
				"Error: password must contain at least one number (0-9)!");
		$("#enterPassword").focus();
		return false;
	}
	var regExp = /[a-z]/;
	if (!regExp.test(pasw1)) {
		$("#registrationLog")
				.text(
						"Error: password must contain at least one lowercase letter (a-z)!");
		$("#enterPassword").focus();
		return false;
	}
	var regExp = /[A-Z]/;
	if (!regExp.test(pasw1)) {
		$("#registrationLog")
				.text(
						"Error: password must contain at least one uppercase letter (A-Z)!");
		$("#enterPassword").focus();
		return false;
	}

	return true;
}

function register() {
	$("#registrationLog").text("");
	if (!validateRegistrationForm()) {
		window.alert("Please review the form data, then submit again.");
		return;
	}
	var registrationData = "username=" + $("#email").val() + "&password="
			+ $("#enterPassword").val();
	var headers = {};
	headers['Content-Type'] = 'application/x-www-form-urlencoded';
	headers['Accept'] = 'application/json';

	context.user['firstName'] = $("#firstName").val();
	context.user['lastName'] = $("#lastName").val();
	context.user['userName'] = $("#email").val();

	doPost(context.links['REGISTER'].href, registrationData, headers, function(
			data, textStatus, jqXHR) {
		// window.alert("registration successful");
		context.aggregatorUser = data;

		saveUserLinks(context.aggregatorUser.hypermedia);

		context.token = {};
		context.token['value'] = jqXHR.getResponseHeader("Authorized-By");
		context.token['expires'] = jqXHR.getResponseHeader("Expires");

		updateUser();

	}, function(jqXHR, textStatus, errorThrown) {
		Window
				.alert("registration failed : " + textStatus + ", "
						+ errorThrown);
	});
	return true;
}

// sets the user's personal data and updates the server
function updateUser() {
	context.aggregatorUser.personalData.firstName = context.user.firstName;
	context.aggregatorUser.personalData.lastName = context.user.lastName;
	context.aggregatorUser.personalData.userName = context.user.userName;

	var headers = {};
	headers['Content-Type'] = "application/json";
	headers['Accept'] = "application/json";
	headers['Authorized-By'] = context.token['value'];

	var updateLink = context.userLinks['UPDATE'];
	doPut(updateLink['href'], JSON.stringify(context.aggregatorUser), headers,
			function(data, textStatus, jqXHR) {
				context.aggregatorUser = data;

				sessionStorage.setItem("context", JSON.stringify(context));
				window.location.href = "user.html";
			}, function(jqXHR, textStatus, errorThrown) {
				$("#log").text(
						"user update error : " + textStatus + ", "
								+ errorThrown);
			});
}

function saveUserLinks(hypermedia) {
	context.userLinks = {};
	for (index in hypermedia['links']) {
		var link = hypermedia['links'][index];
		context.userLinks[link['rel']] = link;
	}
}
