String.prototype.getBytes = function () {
  var bytes = [];
  for (var i = 0; i < this.length; ++i) {
    bytes.push(this.charCodeAt(i));
  }
  return bytes;
};

// this is our context object
var context = undefined;

$(document).ready(
	function() {
		
		// behavior init
		if($("#addAttribute").length != 0)
			$("#addAttribute").on('click',null,
				function() { 
					createAttribute(); 
					return false; 
				});
		if($("#logout").length != 0)
			$("#logout").on('click',null,
					function() { 
				logout(); 
				return false;
			});
		if($("#addEvent").length != 0)
			$("#addEvent").on('click',null,
				function() { 
					createEvent(); 
					return false; 
				});
		
		// data init
		var contextString = sessionStorage.getItem("context");
		context = JSON.parse(contextString);
		if(context != undefined) {
			printUser();
			getEventsForUser();
		} else {
			window.alert("unable to render user data");
		}
	}
);

function printUser() {
	$("#userId").text("User ID : " + context.aggregatorUser.id);
	$("#firstName").text("first name : " + context.aggregatorUser.personalData.firstName);
	$("#lastName").text("last name : " + context.aggregatorUser.personalData.lastName);
	$("#userName").text("username : " + context.aggregatorUser.personalData.userName);
}

function getEventsForUser() {
	var headers = {};
	headers['Content-Type'] = "application/json";
	headers['Accept'] = "application/json";
	headers['Authorized-By'] = context.token['value'];
	
	var getEventsLink = context.userLinks['EVENTS'];
	
	doGet(getEventsLink['href'], null, headers,
	function(data, textStatus, jqXHR) {
		
		context.aggregatorUser.events = data;
		var events = [];
		events = data.events;
		if(events == null || events.length == 0) {
			printEvent(null);
		} else {
			for (var x in events){
			   printEvent(events[x], x);
			}
		}
		
	}, function(jqXHR, textStatus, errorThrown) {
		$("#log").text(
				"error during events retrieval : " + textStatus + ", "
						+ errorThrown);
	});
}

function logout() {
	var headers = {};
	headers['Content-Type'] = "application/json";
	headers['Accept'] = "application/json";
	headers['Authorized-By'] = context.token['value'];
	
	var link = context.links['LOGOUT'];
	
	doPost(link['href'], null, headers,
	function(data, textStatus, jqXHR) {
        window.location.href = "index.html";
	}, function(jqXHR, textStatus, errorThrown) {
		$("#log").text("error logging out : " + textStatus + ", " + errorThrown);
	});
}

function printEvent(event, index) {
	if(event == null) {
		$("#events").append("<p>No events yet</p>");
		return;
	}
	var eventDivId = "event_"+index;
	$("#events").append("<div id=\""+eventDivId+"\" class=\"boxed\"></div>");
	$("#"+eventDivId).append("<p>ID : "+event.id+"</p>");
	$("#"+eventDivId).append("<p>startTime : "+event.startTime+"</p>");
	$("#"+eventDivId).append("<p>endTime : "+event.endTime+"</p>");
	$("#"+eventDivId).append("<p>label : "+event.label+"</p>");
	$("#"+eventDivId).append("<p>type : "+event.type+"</p>");
	$("#"+eventDivId).append("<p>attributes : </p>");
	
	var attrs = event.attributes.entry;
	for (var x in attrs){
		var attr = attrs[x];
		$("#"+eventDivId).append("<p>"+attr.key+" : [" + attr.value.descriptor + ", " + attr.value.value +"]</p>");
	}
}

var attributesForEvent = 0;
function createAttribute() {
	var attribId = "attrib_"+attributesForEvent;
	var fragment = "<div class=\"grid\" id=\""+attribId+"\">" +
	"<input type=\"text\" id=\"key\" placeholder=\"key\" class=\"stacked\">" +
	"<input type=\"text\" id=\"value\" placeholder=\"value\" class=\"stacked\">" +
	"<input type=\"text\" id=\"desc\" placeholder=\"descriptor\" class=\"stacked\">" +
	"</div>";
	$("#attributes").append(fragment);
	$("#attributes > #"+attribId+" > #key").focus();
	attributesForEvent++;
}

function createEvent() {
	var event = {};
	var start = $("#eventForm > #start > div > #date").val();
	if(start == "") {
		$("#log").text("start time is mandatory");
		return false;
	}
	event.startTime = new Date(start).toISOString();
	var end = $("#eventForm > #end > div > #date").val();
	if(end == "") {
		$("#log").text("end time is mandatory");
		return false;
	}
	event.endTime = new Date(end).toISOString();
	event.type = $("#eventForm > div > #type").val();
	event.label = $("#eventForm > div > #label").val();
	event.data = $("#eventForm > div > #data").val().getBytes();
	
	event.attributes = {};
	event.attributes.entry = [];
	for(i = 0; i < attributesForEvent; i++) {
		var attribute = {};
		attribute.key = $("#eventForm > #attributes > #attrib_"+i+" > #key").val();
		attribute.value = {};
		attribute.value.value = $("#eventForm > #attributes > #attrib_"+i+" > #value").val();
		attribute.value.descriptor = $("#eventForm > #attributes > #attrib_"+i+" > #desc").val();
		event.attributes.entry.push(attribute);
	}
	pushEvent(event);
}

function pushEvent(event) {
	var events = {};
	events['events'] = [];
	events.events.push(event);
	
	console.log(JSON.stringify(events));
	
	var headers = {};
	headers['Content-Type'] = "application/json";
	headers['Accept'] = "application/json";
	headers['Authorized-By'] = context.token['value'];
	
	var getEventsLink = context.userLinks['ADD_EVENTS'];
	
	doPost(getEventsLink['href'], JSON.stringify(events), headers,
	function(data, textStatus, jqXHR) {
		$("#log").text("event added succesfully");
        $('#formReset').click();
	}, function(jqXHR, textStatus, errorThrown) {
		$("#log").text("error adding event : " + textStatus + ", " + errorThrown);
	});
}

function doGet(url, params, headers, onSuccess, onError) {
	console.log('perform GET on ' + url);
	$.ajax({
		type : 'GET',
		url : url,
		data : params,
		contentType : "application/json",
		dataType : "json",
		headers : headers,
		success : onSuccess,
		error : onError
	});
}

function doPost(url, content, headers, onSuccess, onError) {
	console.log('perform POST of ' + content + ' on ' + url);
	$.ajax({
		type : 'POST',
		url : url,
		data : content,
		headers : headers,
		success : onSuccess,
		error : onError
	});
}


function doPut(url, content, headers, onSuccess, onError) {
	console.log('perform PUT of ' + content + ' on ' + url);
	$.ajax({
		type : 'PUT',
		url : url,
		data : content,
		headers : headers,
		success : onSuccess,
		error : onError
	});
}
