var fakedata = {
	"Goals" : [ {
		"description" : "Lose 5 kg in 3 months.",
		"importance" : "LOW",
		"status" : "ACTIVE",
		"startDate" : "2014-12-03",
		"endDate" : "2015-03-03",
		"subGoal" : [ {
			"description" : "Keep caloric intake under 1900/day",
			"referenceValue" : "1900",
			"operator" : "LE",
			"type" : "MeasurableGoal",
			"attributes" : {
				"entry" : [ {
					"key" : "measurement unit",
					"value" : {
						"value" : "calorie",
						"descriptor" : "energy"
					}
				}, {
					"key" : "compliance",
					"value" : {
						"value" : "BAD",
						"descriptor" : "0% achieved so far"
					}
				} ]
			}
		} ],
		"attributes" : {
			"entry" : [ {
				"key" : "measurement unit",
				"value" : {
					"value" : "kg",
					"descriptor" : "weight"
				}
			}, {
				"key" : "initial",
				"value" : {
					"value" : "86",
					"descriptor" : "starting weight"
				}
			}, {
				"key" : "progress",
				"value" : {
					"value" : "BAD",
					"descriptor" : "0 Kg lost so far."
				}
			}, {
				"key" : "expected",
				"value" : {
					"value" : "81",
					"descriptor" : "expected final weight"
				}
			} ]
		}
	}, {
		"description" : "Avoid a sedentary lifestyle.",
		"importance" : "NORMAL",
		"status" : "ACTIVE",
		"startDate" : "2014-11-01",
		"subGoal" : [ {
			"description" : "Walk (or run) at least 40000 steps per week",
			"referenceValue" : "40000",
			"operator" : "GE",
			"type" : "MeasurableGoal",
			"attributes" : {
				"entry" : [ {
					"key" : "measurement unit",
					"value" : {
						"value" : "step",
						"descriptor" : "activity"
					}
				}, {
					"key" : "progress",
					"value" : {
						"value" : "GOOD",
						"descriptor" : "80% compliance so far"
					}
				}, {
					"key" : "frequency",
					"value" : {
						"value" : "week",
						"descriptor" : "check frequency"
					}
				} ]
			}
		} ]
	}, {
		"description" : "Increase sleep quality and quantity.",
		"importance" : "HIGH",
		"status" : "ACTIVE",
		"startDate" : "2014-10-15",
		"subGoal" : [ {
			"description" : "Sleep at least 7 hours every night",
			"referenceValue" : "7",
			"operator" : "GE",
			"type" : "MeasurableGoal",
			"attributes" : {
				"entry" : [ {
					"key" : "measurement unit",
					"value" : {
						"value" : "hour",
						"descriptor" : "duration"
					}
				}, {
					"key" : "progress",
					"value" : {
						"value" : "FAIR",
						"descriptor" : "65% compliance so far"
					}
				}, {
					"key" : "frequency",
					"value" : {
						"value" : "day",
						"descriptor" : "check frequency"
					}
				} ]
			}
		}, {
			"description" : "Go to bed by 11 PM every night",
			"referenceValue" : "23",
			"operator" : "LE",
			"type" : "MeasurableGoal",
			"attributes" : {
				"entry" : [ {
					"key" : "measurement unit",
					"value" : {
						"value" : "hour",
						"descriptor" : "time of day"
					}
				}, {
					"key" : "progress",
					"value" : {
						"value" : "BAD",
						"descriptor" : "35% compliance so far"
					}
				}, {
					"key" : "frequency",
					"value" : {
						"value" : "day",
						"descriptor" : "check frequency"
					}
				} ]
			}
		} ]
	} ],
	"moreGoals" : [ {
		"description" : "An old Goal",
		"importance" : "LOW",
		"status" : "COMPLETED",
		"startDate" : "2014-06-01",
		"endDate" : "2014-09-01",
	}, {
		"description" : "Another old Goal",
		"importance" : "NORMAL",
		"status" : "CANCELLED",
		"startDate" : "2014-02-01",
		"endDate" : "2014-08-01",
	}, {
		"description" : "A third old Goal",
		"importance" : "HIGH",
		"status" : "COMPLETED",
		"startDate" : "2014-04-20",
		"endDate" : "2014-07-01",
	}, {
		"description" : "A fourth old Goal",
		"importance" : "MEDIUM",
		"status" : "FAILED",
		"startDate" : "2014-03-15",
		"endDate" : "2014-09-01",
	} ],
	"Reminders" : [

	],
	"moreReminders" : [

	],
	"Reports" : [
			{
				"type" : "BPCO",
				"class" : "fatigue",
				"value" : "100",
				"unit" : "%",
				"reported" : "2014-11-31 18:45:35",
				"description" : "Fatigue assessment at the end of a 60 minute workout"
			},
			{
				"type" : "Cardio",
				"class" : "instant heart rate",
				"value" : "160",
				"unit" : "bpm",
				"reported" : "2014-11-23 19:17:23",
				"description" : "Heart rate measurement made at the end of a 30 minute jogging session"
			},
			{
				"type" : "Stroke",
				"class" : "headache",
				"value" : "strong",
				"unit" : "no",
				"reported" : "2014-11-11 07:25:31",
				"description" : "Self report of a strong headache soon after waking up"
			} ],
	"moreReports" : [ {
		"reported" : "(more than 2 months old)",
		"description" : "... The old symptom data ..."
	}, {
		"reported" : "(3 months old)",
		"description" : "... The old symptom data ..."
	}, {
		"reported" : "(more than 3 months old)",
		"description" : "... The old symptom data ..."
	} ],
	"goalForm" : {
		"description" : undefined,
		"metric" : undefined,
		"expected" : undefined,
		"initial" : undefined,
		"unit" : undefined,
		"start" : undefined,
		"end" : undefined,
		"importance" : undefined,
		"frequency" : undefined,
		"subGoals" : []
	},
	"reportForm" : {
		"reported" : undefined,
		"type" : undefined,
		"value" : undefined,
		"class" : undefined,
		"description" : undefined,
		"unit" : undefined
	},
	"reminderForm" : {
		"created" : undefined,
		"dayTime" : undefined,
		"weekDay" : undefined,
		"frequency" : undefined,
		"timeout" : undefined,
		"type" : undefined,
		"text" : undefined
	},
	"profile" : {
		"firstName" : "Francesco",
		"lastName" : "Foresti",
		"username" : "f.foresti@i-piu.it",
		"gender" : "male",
		"birthDate" : "1978-06-05",
		"condition" : "COPD"
	},
	"profileForm" : {
		"firstName" : undefined,
		"lastName" : undefined,
		"userName" : undefined,
		"password" : undefined,
		"birthDate" : undefined,
		"gender" : {
			"choices" : [{ type : "Male", isSelected : true }, {type : "Female", isSelected : false}],
			"value" : undefined,
		},
		"condition" :  {
			"choices" : [
			             { type : "COPD", isSelected : true }, 
			             { type : "Stroke", isSelected : false }, 
			             { type : "Dementia", isSelected : false}
			],
			"value" : undefined,
		}
		,
		save : function(source,target) {
			var observableTarget = $.observable(target);
			if(source.firstName != undefined)
				observableTarget.setProperty("firstName",source.firstName);
			if(source.lastName != undefined)
				observableTarget.setProperty("lastName",source.lastName);
			if(source.userName != undefined)
				observableTarget.setProperty("username",source.userName);
			if(source.gender.value != undefined)
				observableTarget.setProperty("gender",source.gender.value);
			if(source.birthDate != undefined)
				observableTarget.setProperty("birthDate",source.birthDate);
			if(source.condition.value != undefined)
				observableTarget.setProperty("condition",source.condition.value);
		}
	}
}
