/**
 * requires my.js
 */

var goal_collapse_id = 0;
var report_collapse_id = 0;
jQuery(document).ready(
		function($) {
			$('#tabs').tab();

			$.when(iplus.renderer.load("welcome")
			).done(
					function() {
						iplus.renderer.render("welcome", "#welcome", fakedata.profile, null);
					});
			$.when(iplus.renderer.load("profile"), 
					iplus.renderer.load("profile.form")
			).done(
					function() {
						iplus.renderer.render("profile", "#profile_view", fakedata.profile, null);
						iplus.renderer.link("profile.form", "#profile_form", fakedata.profileForm);
					});
			$.when(iplus.renderer.load("subgoal"), 
				   iplus.renderer.load("attribute"),
				   iplus.renderer.load("status")
				).done(
					function() {
						for ( var index in fakedata.Goals) {
							iplus.renderer.render("goal",
									"#goal_accordion", fakedata.Goals[index],
									{
										'{collapser_id}' : 'g' + goal_collapse_id
									});
							goal_collapse_id++;
						}
					});

			$.when(iplus.renderer.load("report")).done(
					function() {
						for ( var index in fakedata.Reports) {
							iplus.renderer.render("report",
									"#report_accordion",
									fakedata.Reports[index], 
									{
										'{collapser_id}' : 'rp' + report_collapse_id
									});
							report_collapse_id++;
						}
					});

			$(document.body).addClass("unselectable");
		});

$('.tab-pane .btn').on('click', function(e) {
	e.preventDefault();
	var $this = $(this);
	$('.active > .collapse-group').find('.collapse').collapse('toggle');
});
$('#update_profile_submit').on('click', function(e) {
	e.preventDefault();
	var $this = $(this);
	$('#update_profile_submit').parent().collapse('toggle');
});

$('#add_goal').click(function() {
	$('#new_goal_content').attr('src', 'wizards/new_goal.html');
	$('#new_goal_modal').modal({
		show : true
	})
});

$('#update_profile_submit').click(function() {
		var output = "updating user profile :  {\n";
		for(var key in fakedata.profileForm) {
			if (typeof(fakedata.profileForm[key]) == "function") {
				continue;
			}
			if(key == 'gender' || key == 'condition')
				output += key + " : " + fakedata.profileForm[key].value + ",\n"
			else
				output += key + " : " + fakedata.profileForm[key] + ",\n"
		}
		output += "}"
//		alert(output);
		fakedata.profileForm.save(fakedata.profileForm, fakedata.profile);
		iplus.renderer.refresh("profile", "#profile_view", fakedata.profile, null);
		iplus.renderer.refresh("welcome", "#welcome", fakedata.profile, null);
});

$('#add_report').click(function() {
	$('#new_report_content').attr('src', 'wizards/new_report.html');
	$('#new_report_modal').modal({
		show : true
	})
});

$('#add_reminder').click(function() {
	$('#new_reminder_content').attr('src', 'wizards/new_reminder.html');
	$('#new_reminder_modal').modal({
		show : true
	})
});

$('#view_more_goals').click(function() {
	add_more_goals();
});

$('#view_more_reports').click(function() {
	add_more_reports();
});

$('#view_more_reminders').click(function() {
});

function add_more_goals() {
	for ( var index in fakedata.moreGoals) {
		iplus.renderer.render("goal", "#goal_accordion",
				fakedata.moreGoals[index], {
					'{collapser_id}' : 'd' + goal_collapse_id
				});
		goal_collapse_id++;
	}
}

function add_more_reports() {
	for ( var index in fakedata.moreReports) {
		iplus.renderer.render("report",
				"#report_accordion",
				fakedata.moreReports[index], {
					'{collapser_id}' : 'rp'
							+ report_collapse_id
				});
		report_collapse_id++;
	}
}

function add_more_reminders() {
	window.alert("sorry, this is not mocked up yet.")
}
