/**
 * requires my.js
 */
$(document).ready(
		function() {
			$('#rootwizard').bootstrapWizard(
					{
						onNext : function(tab, navigation, index) {
							var $total = navigation.find('li').length;
							var $current = index + 1;
							var $percent = ($current / $total) * 100;
							$('#rootwizard').find('.bar').css({
								width : $percent + '%'
							});
							$('#rootwizard').find('.pager .previous')
									.removeClass('disabled');
						},
						onPrevious : function(tab, navigation, index) {
							var $total = navigation.find('li').length;
							var $current = index + 1;
							var $percent = ($current / $total) * 100;
							$('#rootwizard').find('.bar').css({
								width : $percent + '%'
							});
						},
						onTabClick : function(tab, navigation, index) {
							return false;
						},
						onTabShow : function(tab, navigation, index) {
							var $total = navigation.find('li').length;
							var $current = index + 1;
							// If it's the last tab then hide the last button
							// and show the finish instead
							if ($current >= $total) {
								$('#rootwizard').find('.pager .next').hide();
								$('#rootwizard').find('.pager .finish').show();
								$('#rootwizard').find('.pager .finish').removeClass('disabled');
							} else {
								$('#rootwizard').find('.pager .next').show();
								$('#rootwizard').find('.pager .finish').hide();
							}
						}
					});

			$('#rootwizard .finish').click(function() {
				fakedata.reminderForm.created = new Date().toISOString();
				var output = "submitting self-report :  {\n";
				for(var key in fakedata.reportForm) {
					output += key + " : " + fakedata.reportForm[key] + ",\n"
				}
				output += "}"
				alert(output);
			});
			
			$.when(
					// loads templates asnchronously into $.templates
					iplus.renderer.load("report.form.desc"),
					iplus.renderer.load("report.form.symptom"),
					iplus.renderer.load("report.form.type"),
					iplus.renderer.load("report.form.value")
			).done(
				function() {
					
					// renders (and then links) each template to the
					// corresponding form tab
					
					iplus.renderer.link("report.form.desc", "#tab1", fakedata.reportForm);
					iplus.renderer.link("report.form.symptom", "#tab2", fakedata.reportForm);
					iplus.renderer.link("report.form.type", "#tab3", fakedata.reportForm);
					iplus.renderer.link("report.form.value", "#tab4", fakedata.reportForm);
					
				}
			);

			$(document.body).addClass("unselectable");
});